use crate::db_connection::DbPool;
use crate::handlers::pool_handler;
use crate::models::user::{RegisterUser, User};
use actix_web::{web, HttpResponse};

pub fn register(
    new_user: web::Json<RegisterUser>,
    pool: web::Data<DbPool>,
) -> Result<HttpResponse, HttpResponse> {
    let my_pool = pool_handler(pool)?;
    let register_user = new_user
        .into_inner()
        .validation()
        .map_err(|e| HttpResponse::InternalServerError().json(e.to_string()))?;

    User::create(register_user, &my_pool)
        .map(|user| HttpResponse::Ok().json(user))
        .map_err(|e| HttpResponse::InternalServerError().json(e.to_string()))
}
